XdkWrl: TimeSensor Class Reference

Home | Hierarchy | Members | Alphabetical | Related Pages

# TimeSensor Class Reference
[Standard Node Types]

`#include <timesensor.h>`

Inherits Node.

List of all members.

## Public Member Functions
| TimeSensor (const char *name="")
virtual | ~TimeSensor ()
virtual unsigned int | nbFields () const
virtual FieldHandle | field (const std::string &n)
virtual FieldHandle | field (unsigned int i)
virtual bool | isSetToDefaultValue (unsigned int i) const
virtual unsigned int | nbEventsIn () const
virtual EventInHandle | eventIn (const std::string &n)
virtual EventInHandle | eventIn (unsigned int i)
virtual unsigned int | nbEventsOut () const
virtual EventOutHandle | eventOut (const std::string &n)
virtual EventOutHandle | eventOut (unsigned int i)
const char * | typeName () const
virtual Node * | duplicate () const
virtual Node * | duplicate (std::map< const Node *, Node * > &) const
## Public Attributes
Exposed Fields
A field that is capable of receiving events via an eventIn to change its value(s), and generating events via an eventOut when its value(s) change.
SFTime | cycleInterval
SFBool | enabled
SFBool | loop
SFTime | startTime
SFTime | stopTime
Events In
EventIn< SFTime > | set_cycleInterval
EventIn< SFBool > | set_enabled
EventIn< SFBool > | set_loop
EventIn< SFTime > | set_startTime
EventIn< SFTime > | set_stopTime
Events Out
EventOut< SFTime > | cycleTime
EventOut< SFFloat > | fraction_changed
EventOut< SFBool > | isActive
EventOut< SFTime > | time
EventOut< SFTime > | cycleInterval_changed
EventOut< SFBool > | enabled_changed
EventOut< SFBool > | loop_changed
EventOut< SFTime > | startTime_changed
EventOut< SFTime > | stopTime_changed

## Detailed Description

Here is the documentation for this node type, from the ISO standard.

## 6.69 TimeSensor

TimeSensor nodes generate events as time passes. TimeSensor nodes can be used for many purposes including:

1. driving continuous simulations and animations;
2. controlling periodic activities (e.g., one per minute);
3. initiating single occurrence events such as an alarm clock.

The TimeSensor node contains two discrete eventOuts: isActive and cycleTime. The isActive eventOut sends TRUE when the TimeSensor node begins running, and FALSE when it stops running. The cycleTime eventOut sends a time event at startTime and at the beginning of each new cycle (useful for synchronization with other time-based objects). The remaining eventOuts generate continuous events. The fraction_changed eventOut, an SFFloat in the closed interval [0,1], sends the completed fraction of the current cycle. The time eventOut sends the absolute time for a given simulation tick.

If the enabled exposedField is TRUE, the TimeSensor node is enabled and may be running. If a set_enabled FALSE event is received while the TimeSensor node is running, the sensor performs the following actions:

4. evaluates and sends all relevant outputs;
5. sends a FALSE value for isActive;
6. disables itself.

Events on the exposedFields of the TimeSensor node (e.g., set_startTime) are processed and their corresponding eventOuts (e.g., startTime_changed) are sent regardless of the state of the enabled field. The remaining discussion assumes enabled is TRUE.

The loop, startTime, and stopTime exposedFields and the isActive eventOut and their effects on the TimeSensor node are discussed in detail in 4.6.9, Time-dependent nodes. The "cycle" of a TimeSensor node lasts for cycleInterval seconds. The value of cycleInterval shall be greater than zero.

A cycleTime eventOut can be used for synchronization purposes such as sound with animation. The value of a cycleTime eventOut will be equal to the time at the beginning of the current cycle. A cycleTime eventOut is generated at the beginning of every cycle, including the cycle starting at startTime. The first cycleTime eventOut for a TimeSensor node can be used as an alarm (single pulse at a specified time).

When a TimeSensor node becomes active, it generates an isActive = TRUE event and begins generating time, fraction_changed, and cycleTime events which may be routed to other nodes to drive animation or simulated behaviours. The behaviour at read time is described below. The time event sends the absolute time for a given tick of the TimeSensor node (time fields and events represent the number of seconds since midnight GMT January 1, 1970).

fraction_changed events output a floating point value in the closed interval [0, 1]. At startTime the value of fraction_changed is 0. After startTime, the value of fraction_changed in any cycle will progress through the range (0.0, 1.0]. At startTime + N × cycleInterval, for N = 1, 2, ..., that is, at the end of every cycle, the value of fraction_changed is 1.

Let now represent the time at the current simulation tick. Then the time and fraction_changed eventOuts can then be computed as:

        time = now
        temp = (now - startTime) / cycleInterval
        f    = fractionalPart(temp)
        if (f == 0.0 && now > startTime) fraction_changed = 1.0
        else fraction_changed = f

where`fractionalPart(x)` is a function that returns the fractional part, (that is, the digits to the right of the decimal point), of a nonnegative floating point number.

A TimeSensor node can be set up to be active at read time by specifying loop TRUE (not the default) and stopTime less than or equal to startTime (satisfied by the default values). The time events output absolute times for each tick of the TimeSensor node simulation. The time events shall start at the first simulation tick greater than or equal to startTime. time events end at stopTime, or at startTime + N × cycleInterval for some positive integer value of N, or loop forever depending on the values of the other fields. An active TimeSensor node shall stop at the first simulation tick when now >= stopTime > startTime.

No guarantees are made with respect to how often a TimeSensor node generates time events, but a TimeSensor node shall generate events at least at every simulation tick. TimeSensor nodes are guaranteed to generate final time and fraction_changed events. If loop is FALSE at the end of the Nth cycleInterval and was TRUE at startTime + M × cycleInterval for all 0 < M < N, the final time event will be generated with a value of (startTime + N × cycleInterval) or stopTime (if stopTime > startTime), whichever value is less. If loop is TRUE at the completion of every cycle, the final event is generated as evaluated at stopTime (if stopTime > startTime) or never.

An active TimeSensor node ignores set_cycleInterval and set_startTime events. An active TimeSensor node also ignores set_stopTime events for set_stopTime less than or equal to startTime. For example, if a set_startTime event is received while a TimeSensor node is active, that set_startTime event is ignored (the startTime field is not changed, and a startTime_changed eventOut is not generated). If an active TimeSensor node receives a set_stopTime event that is less than the current time, and greater than startTime, it behaves as if the stopTime requested is the current time and sends the final events based on the current time (note that stopTime is set as specified in the eventIn).

A TimeSensor read from a VRML file shall generate isActive TRUE, time and fraction_changed events if the sensor is enabled and all conditions for a TimeSensor to be active are met.

## Constructor & Destructor Documentation

TimeSensor | ( | const char * | name = `""` | ) |

Construct a node with all its fields set to default value, which is equivalent to the code below:

      cycleInterval.setNbSeconds(1);
      enabled = true;
      loop = false;
      startTime.setNbSeconds(0);
      stopTime.setNbSeconds(0);

~TimeSensor | ( |  | ) | `[virtual]`

Virtual destructor, does nothing

## Member Function Documentation

unsigned int nbFields | ( |  | ) | const`[inline, virtual]`

Returns the number of fields (exposed or not) for this node type.

Implements Node.

wrl::Node::FieldHandle field | ( | const std::string & | n | ) | `[virtual]`

Return a handle on the field named `n` of the node or a "unknown" typed handle if there is no such field. Valid names are:

- cycleInterval
- enabled
- loop
- startTime
- stopTime

Implements Node.

wrl::Node::FieldHandle field | ( | unsigned int | n | ) | `[virtual]`

Return a handle on the `i` th field of the node or a "unknown" typed handle if there is no such node. Here is how `i` is related to fields:

- 0 : cycleInterval
- 1 : enabled
- 2 : loop
- 3 : startTime
- 4 : stopTime This function is useful, with nbFields() if you want to traverse all fields of a Node.

Implements Node.

bool isSetToDefaultValue | ( | unsigned int | i | ) | const`[virtual]`

Implements Node.

unsigned int nbEventsIn | ( |  | ) | const`[inline, virtual]`

Returns the number of events in for this node type.

Implements Node.

wrl::Node::EventInHandle eventIn | ( | const std::string & | n | ) | `[virtual]`

Return a handle on the event in named `n` of the node or a "unknown" typed handle if there is no such event. Valid names are:

- set_cycleInterval
- set_enabled
- set_loop
- set_startTime
- set_stopTime

Implements Node.

wrl::Node::EventInHandle eventIn | ( | unsigned int | n | ) | `[virtual]`

Return a handle on the `i` th event in of the node or a "unknown" typed handle if there is no such node. emarks This class has no eventIn. This function is useful, with nbEventsIn() if you want to traverse all events in of a Node.

Implements Node.

unsigned int nbEventsOut | ( |  | ) | const`[inline, virtual]`

Returns the number of events out for this node type.

Implements Node.

wrl::Node::EventOutHandle eventOut | ( | const std::string & | n | ) | `[virtual]`

Return a handle on the event out named `n` of the node or a "unknown" typed handle if there is no such event. Valid names are:

- cycleTime
- fraction_changed
- isActive
- time
- cycleInterval_changed
- enabled_changed
- loop_changed
- startTime_changed
- stopTime_changed

Implements Node.

wrl::Node::EventOutHandle eventOut | ( | unsigned int | n | ) | `[virtual]`

Return a handle on the `i` th event out of the node or a "unknown" typed handle if there is no such node. Here is how `i` is related to fields:

- 0 : cycleTime
- 1 : fraction_changed
- 2 : isActive
- 3 : time
- 4 : cycleInterval_changed
- 5 : enabled_changed
- 6 : loop_changed
- 7 : startTime_changed
- 8 : stopTime_changed This function is useful, with nbEventsOut() if you want to traverse all events in of a Node.

Implements Node.

const char * typeName | ( |  | ) | const`[inline, virtual]`

Returns `"TimeSensor"`. Useful for printing.

Implements Node.

wrl::Node * duplicate | ( |  | ) | const`[virtual]`

Returns a deep copy of this node, that is a fully independant node with all children (if any) also copied. This is mainly useful for instanciating protos.

Implements Node.

virtual Node* duplicate | ( | std::map< const Node *, Node * > & |  | ) | const`[virtual]`

Implements Node.

## Member Data Documentation

SFTime cycleInterval

See Detailed Description for meaning of this field. Default value is set to

           cycleInterval.setNbSeconds(1);

SFBool enabled

See Detailed Description for meaning of this field. Default value is set to

           enabled = true;

SFBool loop

See Detailed Description for meaning of this field. Default value is set to

           loop = false;

SFTime startTime

See Detailed Description for meaning of this field. Default value is set to

           startTime.setNbSeconds(0);

SFTime stopTime

See Detailed Description for meaning of this field. Default value is set to

           stopTime.setNbSeconds(0);

EventIn<SFTime> set_cycleInterval

Set event associated to exposedField cycleInterval

EventIn<SFBool> set_enabled

Set event associated to exposedField enabled

EventIn<SFBool> set_loop

Set event associated to exposedField loop

EventIn<SFTime> set_startTime

Set event associated to exposedField startTime

EventIn<SFTime> set_stopTime

Set event associated to exposedField stopTime

EventOut<SFTime> cycleTime

See Detailed Description for meaning of this event.

EventOut<SFFloat> fraction_changed

See Detailed Description for meaning of this event.

EventOut<SFBool> isActive

See Detailed Description for meaning of this event.

EventOut<SFTime> time

See Detailed Description for meaning of this event.

EventOut<SFTime> cycleInterval_changed

Changed event associated to exposedField cycleInterval

EventOut<SFBool> enabled_changed

Changed event associated to exposedField enabled

EventOut<SFBool> loop_changed

Changed event associated to exposedField loop

EventOut<SFTime> startTime_changed

Changed event associated to exposedField startTime

EventOut<SFTime> stopTime_changed

Changed event associated to exposedField stopTime

Generated on 5 Jan 2007 with version 1.5.1. |